package compbio.stat.servlet;

import java.io.IOException;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;
import java.util.TreeMap;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import compbio.stat.collector.StatDB;
import compbio.stat.collector.StatProcessor;
import compbio.ws.client.Services;

public class DisplayStat extends HttpServlet {

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		// TODO
		Calendar startTime = Calendar.getInstance();
		startTime.roll(Calendar.YEAR, false);
		Timestamp startDate = new Timestamp(startTime.getTimeInMillis());
		Timestamp stopDate = new Timestamp(new Date().getTime());
		StatDB statdb = null;
		try {
			statdb = new StatDB();

			Map<Services, StatProcessor> stats = new TreeMap<Services, StatProcessor>();
			for (Services service : Services.values()) {
				stats.put(
						service,
						new StatProcessor(statdb.readData(startDate, stopDate,
								service, null)));
			}

			Map<Services, StatProcessor> statsCluster = new TreeMap<Services, StatProcessor>();
			for (Services service : Services.values()) {
				statsCluster.put(
						service,
						new StatProcessor(statdb.readData(startDate, stopDate,
								service, true)));
			}

			Map<Services, StatProcessor> statsLocal = new TreeMap<Services, StatProcessor>();
			for (Services service : Services.values()) {
				statsLocal.put(
						service,
						new StatProcessor(statdb.readData(startDate, stopDate,
								service, false)));
			}
			req.setAttribute("stat", stats);
			req.setAttribute("statTotal", Totals.sumStats(stats));

			req.setAttribute("statCluster", statsCluster);
			req.setAttribute("statLocal", statsLocal);
			req.setAttribute("startDate", startDate.getTime());
			req.setAttribute("stopDate", stopDate.getTime());

			RequestDispatcher dispatcher = req
					.getRequestDispatcher("statpages/Statistics.jsp");
			dispatcher.forward(req, resp);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

}
